<?php defined('BASEPATH') OR exit('No direct script access allowed');
class AccountReports extends CI_Controller {

	public function __construct()
	{
	    parent::__construct();
	    $this->check_isvalidated();
	    $this->load->model('Accounts_model');
	    $this->load->model('AccountsGroup_model');
	    $this->load->model('AccountReport_model');
	    $this->load->model('Employee_model');
	    $this->load->model('Customer_model');
	    $this->load->model('Vendor_model');
	    $this->load->model('COA_model');
		$this->load->model('Sale_model');
		$this->load->model('SaleReport_model');
		$this->load->model('PurchaseReport_model');
		$this->load->model('Area_model');
		$this->load->model('Product_model');
	}

	private function check_isvalidated()
	{
        if(!$this->session->userdata('EmployeeId'))
        { $this->session->set_userdata('url',  current_url()); redirect('Login'); }
	}

	function index()
	{
        $data['Roles'] = $this->Employee_model->GetRoles();
        $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
        $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
        $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
        $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
        $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));
	
		$data['AllAccountsGroup'] = $this->AccountsGroup_model->GetAllAccountGroups();
		$data['AllAccounts'] = $this->Accounts_model->GetAllAccounts();
		$data['CategoryCode'] = $this->COA_model->GetAllCategories();
		$data['CustomerNotification'] = $this->Customer_model->GetNotifications();
		$this->load->view('report/accountreports/account_reports', $data);
	}


	public function LedgerReportCriteria() {
        
		// Category code dropdown
		$CategoryCodes = '';

		$CategoryCode = $this->COA_model->GetAllCategories(); 

		foreach($CategoryCode as  $value)
		{
			$CategoryCodes .= '<option value="'.$value["ChartOfAccountCategoryId"].'"> '.$value['CategoryName'].' </option>';
		}

		$ReportCriteria ='<div style="border:0px solid; width:40%; margin-left:190px;" class="box-header with-border">
					<h3 class="box-title text-light-blue">Report Criteria</h3>
					</div>';
			$ReportCriteria .='<div class="form-group">
			<label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Category Code:</label>
				<div class="input-group date">
													<select style="width:300px;" class="form-control select2" id="CategoryId" name="CategoryId">
															<option value="0">Select Category</option>
															'.$CategoryCodes.'
													</select>
				</div>                  
			</div>'; 
							$ReportCriteria .='<div class="form-group">
			<label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Control Code:</label>
				<div class="input-group date" id="ControlCodeDiv">
													<select style="width:300px;" class="form-control select2" id="ControlCodeId" name="ControlCodeId">
															<option value="0">Select Control Code</option>
													</select>
				</div>
			</div>';
								$ReportCriteria .='<div class="form-group">
			<label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Chart Of Account Code:</label>
				<div class="input-group date" id ="ChartOfAccountDiv">
													<select style="width:300px;" class="form-control select2" id="ChartOfAccountId" name="ChartOfAccountId">
															<option value="0">Select Chart Of Account</option>
													</select>
				</div>                  
			</div>';              
			$ReportCriteria .='<div class="form-group">
			<label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Date From:</label>
				<div class="input-group date">
				<div class="input-group-addon">
					<i class="fa fa-calendar"></i>
				</div>                  
				<input class="form-control" name="StartDate" id="datepicker1" type="text" placeholder="Enter Start Date" style="width:40%;" value="" autocomplete="off">
				</div>                  
			</div>';	   
			$ReportCriteria .='<div class="form-group">
			<label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Date To:</label>
				<div class="input-group date">
				<div class="input-group-addon">
					<i class="fa fa-calendar"></i>
				</div>     
				<input class="form-control" name="OrderDate" id="datepicker2" type="text" placeholder="Enter End Date" style="width:40%;" value="" autocomplete="off">
				</div>                  
			</div>';              
						$ReportCriteria .='<div class="form-group">
			<label style="width:24%;" class="col-sm-2"></label>
				<div class="input-group date">
				<button type="button" id="generate_ledger_report" class="btn  btn-primary">Show Report</button>
				</div>
			</div>';
						print $ReportCriteria;
			$this->load->view("includes/footer");
}	


public function LedgerReport()
	{
	    $CategoryId = $this->input->get('CId');
	    $ControlCodeId = $this->input->get('CCId');
	    $ChartOfAccountId = $this->input->get('COAId');
	    
	    $StartDate =date('Y-m-d', strtotime($this->input->get('StartDate')));
	    $EndDate =date('Y-m-d', strtotime($this->input->get('EndDate')));

	    $data['Roles'] = $this->Employee_model->GetRoles();
	    $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
	    $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
	    $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
	    $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
	    $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
	    $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));
	   	
		if($CategoryId == 1 && $ControlCodeId == 3){
			$data['Detailss'] = $this->Customer_model->GetCustomerById($ChartOfAccountId);
		}
		if($CategoryId == 2 && $ControlCodeId == 2){
			$data['Detailss']   = $this->Vendor_model->GetVendorById($ChartOfAccountId);
		}

		$data['CategoryId']		= $CategoryId;
		$data['ControlCodeId']	= $ControlCodeId;
		
	    $data['LedgerReport'] = $this->AccountReport_model->LedgerReport($StartDate,$EndDate,$CategoryId,$ControlCodeId,$ChartOfAccountId);
	    $data['SubLedgerReport'] = $this->AccountReport_model->SubLedgerReport($StartDate,$EndDate,$CategoryId,$ControlCodeId,$ChartOfAccountId);
		$data['OpenningBalance'] = $this->AccountReport_model->GetOpenningBalance($StartDate,$EndDate,$CategoryId,$ControlCodeId,$ChartOfAccountId);
		
	    $data['GetSettingInformation'] = $this->Employee_model->GetSettingInformation();
	    $data['CustomerNotification'] = $this->Customer_model->GetNotifications();
		$this->load->view('report/accountreports/view_ledgerreport', $data);
	}


function ActivityCriteria() 
	{        

		$ReportCriteria ='<div style="border:0px solid; width:40%; margin-left:190px;" class="box-header with-border">
		<h3 class="box-title text-light-blue">Report Criteria</h3>
		</div>';
		$ReportCriteria .='<div class="form-group">
		<label style="width:24%;" for="ReferencePrefix" class="col-sm-1 control-label">Select Type:</label>
		   <div class="input-group date" id="AccountDiv">
				<select style="width:230px;" class="select2" id="type" name="type">
					<option value="0">Select Type</option>
					<option value="bank">Banks</option>
					<option value="cashbook">Cashbook</option>
				</select>
		   </div>                  
	   </div>';
		$ReportCriteria .='<div class="form-group">
		 <label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Date From:</label>
		   <div class="input-group date">
			 <div class="input-group-addon">
			   <i class="fa fa-calendar"></i>
			 </div>                  
			 <input class="form-control" name="StartDate" id="datepicker1" type="text" placeholder="Enter Start Date" style="width:40%;" value="" autocomplete="off">
		   </div>                  
	   	</div>';	   
	   	$ReportCriteria .='<div class="form-group">
		 <label style="width:24%;" for="OrderDate" class="col-sm-1 control-label">Date To:</label>
		   <div class="input-group date">
			 <div class="input-group-addon">
			   <i class="fa fa-calendar"></i>
			 </div>     
			 <input class="form-control" name="OrderDate" id="datepicker2" type="text" placeholder="Enter End Date" style="width:40%;" value="" autocomplete="off">
		   </div>                  
	   </div>';
           $ReportCriteria .='<div class="form-group">
		 <label style="width:24%;" class="col-sm-2"></label>
		   <div class="input-group date">
			 <button type="button" id="generate_activity_report" class="btn  btn-primary">Show Report</button>
		   </div>
	   </div>';
           print $ReportCriteria;
	   $this->load->view("includes/footer");
}


function GenerateActivityReport()
{
	$StartDate = "";
	$EndDate   = "";
	if($this->input->get('StartDate')){
		$StartDate = date('Y-m-d', strtotime($this->input->get('StartDate')));
	}
	if($this->input->get('EndDate')){
		$EndDate = date('Y-m-d', strtotime($this->input->get('EndDate')));
	}
	
	$Type = $this->input->get('Type');
	// bank method
	$data['LedgerReport'] 	 = ($Type == "bank" || $Type == 0) ? $this->AccountReport_model->LedgerReport($StartDate, $EndDate, 1, 4, 0) : array();
		$data['SubLedgerReport'] = ($Type == "bank" || $Type == 0) ? $this->AccountReport_model->SubLedgerReport($StartDate, $EndDate, 1, 4, 0) : array();
	$data['OpenningBalance'] = ($Type == "bank" || $Type == 0) ? $this->AccountReport_model->GetOpenningBalance($StartDate, $EndDate, 1, 4, 0) : array();
	// cashbook method
	$data['CashbookLedgerReport'] 	 = ($Type == "cashbook" || $Type == 0) ? $this->AccountReport_model->LedgerReport($StartDate, $EndDate, 1, 1, 1) : array();
		$data['CashbookSubLedgerReport'] = ($Type == "cashbook" || $Type == 0) ? $this->AccountReport_model->SubLedgerReport($StartDate, $EndDate, 1, 1, 1) : array();
	$data['CashbookOpenningBalance'] = ($Type == "cashbook" || $Type == 0) ? $this->AccountReport_model->GetOpenningBalance($StartDate, $EndDate, 1, 1, 1) : array();
	
	$data['ReportType']	= $Type;
	$data['GetSettingInformation'] = $this->Employee_model->GetSettingInformation();
	$data['CustomerNotification'] = $this->Customer_model->GetNotifications();
	$this->load->view('report/accountreports/activity_report',$data);
}

function PaymentReportCriteria()
	{
			
	    $StartDate = date("m/d/Y");
	    $Customers = '';
			$Products = '';
	   
        $AllCustomers = $this->Customer_model->GetAllCustomers();
				$AllProducts = $this->Product_model->GetAllProducts();
	    
	    foreach($AllProducts as  $value)
        {
	       $Products .= '<option value="'.$value["ProductId"].'">'.$value['Accountof'].'</option>';
		}

		foreach($AllCustomers as  $value)
        {
	       $Customers .= '<option value="'.$value["CustomerId"].'">'.$value['CustomerName'].'</option>';
		}
	
	    $ReportCriteria ='<div style="width:40%; margin-left:190px;" class="box-header with-border">
	    <h3 class="box-title text-light-blue">Report Criteria</h3>
	    </div>';
		$ReportCriteria .='<div class="form-group">
		<label style="width:24%;" for="Customers" class="col-sm-1 control-label">Member:</label>
		  <div class="input-group date">
		 <select style="width:270px;" class="form-control select2" id="CustomerId">
		   <option value="0" selected="selected">All Members</option>
		   '.$Customers.'
		 </select>
		  </div>
   		</div>';

			 $ReportCriteria .='<div class="form-group">
			 <label style="width:24%;" for="Accounts" class="col-sm-1 control-label">Account of:</label>
				 <div class="input-group date">
				<select style="width:270px;" class="form-control select2" id="ProductId">
					<option value="0" selected="selected">Select Account</option>
					'.$Products.'
				</select>
				 </div>
					</div>';

	    $ReportCriteria .='<div class="form-group">
		     <label style="width:24%;" for="StartDate" class="col-sm-1 control-label">Date From:</label>
		       <div class="input-group date">
			  <div class="input-group-addon">
			     <i class="fa fa-calendar"></i>
			  </div>               
			  <input class="form-control" name="StartDate" id="datepicker1" type="text" placeholder="Enter Start Date" style="width:40%;" value="" autocomplete="off">
		       </div>                  
	    </div>';
	    $ReportCriteria .='<div class="form-group">
		     <label style="width:24%;" for="EndDate" class="col-sm-1 control-label">Date To:</label>
		       <div class="input-group date">
			  <div class="input-group-addon">
			     <i class="fa fa-calendar"></i>
			  </div>     
			  <input class="form-control" name="OrderDate" id="datepicker2" type="text" placeholder="Enter End Date" style="width:40%;" value="" autocomplete="off">
		       </div>                  
	    </div>';
	    $ReportCriteria .='<div class="form-group">
		     <label style="width:24%;" class="col-sm-2"></label>
		       <div class="input-group date">
			  <button type="button" id="generate_payment_report" class="btn  btn-primary">Show Report</button>
		       </div>                  
	    </div>';
	    echo $ReportCriteria;
	    $this->load->view("includes/footer");
	}	

	public function PaymentReceiptDetailReport()
	{
        $CustomerId = $this->input->get('CustomerId');
				$ProductId = $this->input->get('ProductId');
        $SDate = $this->input->get('StartDate');
        $EDate = $this->input->get('EndDate');

        $StartDate = date("Y-m-d", strtotime($SDate));
        $EndDate = date("Y-m-d", strtotime($EDate));
        
        $data['Roles'] = $this->Employee_model->GetRoles();
        $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
        $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
        $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
        $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
        $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));

		$data['AllSales'] = $this->AccountReport_model->GetMembersPayment($CustomerId,$ProductId,$StartDate,$EndDate);
		// echo $this->output->enable_profiler();
		// echo '<pre>'; print_r($data['AllSales']); die;
		$data['GetSettingInformation'] = $this->Employee_model->GetSettingInformation();
        $data['CustomerNotification'] = $this->Customer_model->GetNotifications();
		$this->load->view('report/accountreports/view_leasereport', $data);
	}


}
?>