<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Product extends CI_Controller {

	public function __construct()
	{
	    parent::__construct();	
	    $this->check_isvalidated();
	    $this->load->model('Product_model');
	    $this->load->model('Employee_model');
	    $this->load->model('ProductGroup_model');
	    $this->load->model('Customer_model');
	}
	
	
	private function check_isvalidated()
	{
		if(!$this->session->userdata('EmployeeId'))
		{  $this->session->set_userdata('url',  current_url()); redirect('Login'); }
	}
	        
        
    public function index()
	{
        $data['Roles'] = $this->Employee_model->GetRoles();
        $data['EmployeeRoles'] = $this->Employee_model->GetEmployeeRoles($this->session->userdata('EmployeeId'));
        $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
        $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
        $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
        $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
        $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));
        $data['CustomerNotification'] = $this->Customer_model->GetNotifications();
        $this->load->view('product/products',$data);
	}

    public function Ajax_GetAllProducts()
    {
        $AdministrationRoles = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $Ajax_GetAllProducts=$this->Product_model->Ajax_GetAllProducts($_REQUEST);
            $ViewRecord = '<span style="color:#00a65a;" class="glyphicon glyphicon-th-large"></span>';
            $UpdateRecord = '<span style="color:#0c6aad;" class="fa fa-edit">';

            $data = array();
            $srno = 1;
            foreach($Ajax_GetAllProducts['record'] as $row)
            {
                $nestedData=array(); 
                $nestedData[] = $srno++;
                $nestedData[] = $row['CategoryName'];
                $nestedData[] = $row['Accountof'];
                $nestedData[] = $row["Amount"];
                $id = $row["ProductId"];
                if ($AdministrationRoles[3]['ViewRoles']==1 && $AdministrationRoles[3]['UpdateRoles']==1) {
                $nestedData[] = '<a href="'.base_url().'Product/ViewProduct/'.$id.'" title="View Record">'.$ViewRecord.'</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="'.base_url().'Product/EditProduct/'.$id.'"title="Update Record"><span style="color:#0c6aad;" class="fa fa-edit"></span></a>';
                }
                else{
                $nestedData[] = '<a href="'.base_url().'Product/ViewProduct/'.$id.'" title="View Record">'.$ViewRecord.'</a>';
                }
            
                $data[] = $nestedData;
            }

                $json_data = array(
            "draw" => intval( $_REQUEST['draw'] ),   // for every request/draw by clientside , they send a number as a parameter, when they recieve a response/data they first check the draw number, so we are sending same number in draw. 
            "recordsTotal"    => intval( $Ajax_GetAllProducts['recordsTotal'] ),  // total number of records
            "recordsFiltered" => intval( $Ajax_GetAllProducts['recordsFiltered'] ), // total number of records after searching, if there is no searching then totalFiltered = totalData
            "data" => $data   // total data array
            );
                echo json_encode($json_data);  // send data as json format
        }
	
	
	public function AddProduct()
	{
        $data['Roles'] = $this->Employee_model->GetRoles();
        $data['EmployeeRoles'] = $this->Employee_model->GetEmployeeRoles($this->session->userdata('EmployeeId'));
        $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
        $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
        $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
        $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
        $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));   
        $data['GetAllCategories'] = $this->ProductGroup_model->GetAllCategories();
        $data['GetAllProductGroup'] = $this->ProductGroup_model->GetAllProductGroups();
        $data['GetAllBrands'] = $this->Product_model->GetAllBrands();
        $data['GetColours']= $this->Product_model->GetAllColours();
        $data['CustomerNotification'] = $this->Customer_model->GetNotifications();
        $this->load->view('product/add_product', $data);
	}
        
	
    public function EditProduct($ProductId)
    {
        $data['Roles'] = $this->Employee_model->GetRoles();
        $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
        $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
        $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
        $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
        $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));
/*	    $data['GetAllProductGroup'] = $this->Product_model->Ajax_GetAllProducts('ims_productgroup.CategoryId,ims_productgroup.ProductGroupId,ims_productgroup.ProductGroupName');	*/
        $data['GetAllCategories'] = $this->ProductGroup_model->GetAllCategories();
        $data['GetAllProductGroup'] = $this->ProductGroup_model->GetAllProductGroups();
        $data['GetAllBrands'] = $this->Product_model->GetAllBrands();
        $data['GetColours']= $this->Product_model->GetAllColours();
        $data['GetProduct']= $this->Product_model->GetProduct($ProductId);
        $data['CustomerNotification'] = $this->Customer_model->GetNotifications();
        $this->load->view('product/edit_product', $data);		
    }
	
        
    public function ViewProduct($ProductId)
    {
        $data['Roles'] = $this->Employee_model->GetRoles();
        $data['AdministrationRoles'] = $this->Employee_model->GetAdministrationRoles($this->session->userdata('EmployeeId'));
        $data['SalesRoles'] = $this->Employee_model->GetSalesRoles($this->session->userdata('EmployeeId'));
        $data['PurchasesRoles'] = $this->Employee_model->GetPurchasesRoles($this->session->userdata('EmployeeId'));
        $data['RegistrationRoles'] = $this->Employee_model->GetRegistrationRoles($this->session->userdata('EmployeeId'));
        $data['TransactionRoles'] = $this->Employee_model->GetTransactionRoles($this->session->userdata('EmployeeId'));
        $data['ReportsRoles'] = $this->Employee_model->GetReportsRoles($this->session->userdata('EmployeeId'));
        $data['GetProduct']= $this->Product_model->GetProduct($ProductId);
        $data['CustomerNotification'] = $this->Customer_model->GetNotifications();
        $this->load->view('product/view_product', $data);
    }

        
	public function SaveProduct()
	{
        
    	$data['CategoryId'] = $this->input->post('CategoryId');
        $data['Accountof'] = $this->input->post('Accountof');
        $data['Amount'] = $this->input->post('Amount');
        
        $this->db->insert('pos_products',$data);
		$NewProductId =  $this->db->insert_id();

        if(isset($NewProductId))
        {  
            $this->session->set_flashdata("record_added","Record added successfully."); 
            redirect("Product/ViewProduct/$NewProductId");
        }
	}
	
	
	public function UpdateProduct($ProductId)
	{
	    
        $data['CategoryId'] = $this->input->post('CategoryId');
        $data['Accountof'] = $this->input->post('Accountof');
        $data['Amount'] = $this->input->post('Amount');
	    
        $this->db->where('ProductId',$ProductId)->update('pos_products',$data);  
	    
	    $this->session->set_flashdata("record_update","Record update successfully."); 
	    redirect("Product/ViewProduct/$ProductId");
	
	}

	
	public function DeleteProduct($ProductId)
	{
        if($this->Product_model->DeleteProduct($ProductId)){
        $this->session->set_flashdata("record_deleted","Record deleted successfully."); 
        redirect("Product");
        }
	}
}

?>